Name:          checker-framework
Version:       1.9.13
Release:       1%{?dist}
Summary:       Pluggable type-checking for Java
License:       ASL 2.0 and (GPLv2 with exception) and MIT
URL:           http://types.cs.washington.edu/checker-framework/
Source0:       https://github.com/typetools/checker-framework/archive/%{name}-%{version}.tar.gz
# Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=13724115
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: hamcrest-core
BuildRequires: java-devel
BuildRequires: javapackages-local

BuildArch:     noarch

%description
The Checker Framework enhances Java’s type system to make it
more powerful and useful. This lets software developers
detect and prevent errors in their Java programs.

%package dataflow
Summary:       Dataflow Framework for the Checker Framework

%description dataflow
This package provides Dataflow Framework for the
Checker Framework.

%package javacutil
Summary:       Java library for the Checker Framework

%description javacutil
This package provides a library of utilities shared
by sub-projects in the Checker Framework.

%package stubparser
Summary:       Java parser for Checker Framework stub files

%description stubparser
This package provides the Java parser
for Checker Framework stub files.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{name}-%{version}
find -name '*.class' -print -delete
find -name '*.jar' -print -delete

for s in framework/src/org/checkerframework/framework/util/typeinference/constraint/A2F.java \
  framework/src/org/checkerframework/framework/util/typeinference/constraint/AFConstraint.java \
  framework/src/org/checkerframework/framework/util/typeinference/constraint/F2A.java \
  framework/src/org/checkerframework/qualframework/poly/PolyQual.java \
  framework/src/org/checkerframework/qualframework/poly/QualifiedParameterTypeVariableSubstitutor.java \
  framework/src/org/checkerframework/qualframework/poly/Wildcard.java \
  framework/src/org/checkerframework/qualframework/poly/format/PrettyQualParamsFormatter.java \
  framework/src/org/checkerframework/qualframework/poly/format/SurfaceSyntaxQualParamsFormatter.java \
  framework/src/org/checkerframework/qualframework/poly/qual/Wildcard.java \
  checker/src/org/checkerframework/checker/tainting/qual/ClassTaintingParam.java \
  checker/src/org/checkerframework/checker/tainting/qual/MethodTaintingParam.java \
  checker/src/org/checkerframework/checker/tainting/qual/Tainted.java \
  checker/src/org/checkerframework/checker/tainting/qual/Var.java \
  checker/src/org/checkerframework/checker/tainting/qual/Wild.java \
  stubparser/src/org/checkerframework/stubparser/ASTParser.java \
  stubparser/src/org/checkerframework/stubparser/ASTParserConstants.java \
  stubparser/src/org/checkerframework/stubparser/ASTParserTokenManager.java \
  stubparser/src/org/checkerframework/stubparser/JavaCharStream.java \
  stubparser/src/org/checkerframework/stubparser/JavaParser.java \
  stubparser/src/org/checkerframework/stubparser/ParseException.java \
  stubparser/src/org/checkerframework/stubparser/Token.java \
  stubparser/src/org/checkerframework/stubparser/TokenMgrError.java \
  stubparser/src/org/checkerframework/stubparser/ast/BlockComment.java \
  stubparser/src/org/checkerframework/stubparser/ast/Comment.java \
  stubparser/src/org/checkerframework/stubparser/ast/CompilationUnit.java \
  stubparser/src/org/checkerframework/stubparser/ast/ImportDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/LineComment.java \
  stubparser/src/org/checkerframework/stubparser/ast/Node.java \
  stubparser/src/org/checkerframework/stubparser/ast/PackageDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/TypeParameter.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/AnnotationDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/AnnotationMemberDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/BodyDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/ClassOrInterfaceDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/ConstructorDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/EmptyMemberDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/EmptyTypeDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/EnumConstantDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/EnumDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/FieldDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/InitializerDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/JavadocComment.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/MethodDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/ModifierSet.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/Parameter.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/TypeDeclaration.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/VariableDeclarator.java \
  stubparser/src/org/checkerframework/stubparser/ast/body/VariableDeclaratorId.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/AnnotationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ArrayAccessExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ArrayCreationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ArrayInitializerExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/AssignExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/BinaryExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/BooleanLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/CastExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/CharLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ClassExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ConditionalExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/DoubleLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/EnclosedExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/Expression.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/FieldAccessExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/IntegerLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/IntegerLiteralMinValueExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/InstanceOfExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/LiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/LongLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/LongLiteralMinValueExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/MarkerAnnotationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/MemberValuePair.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/MethodCallExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/NameExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/NormalAnnotationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/NullLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ObjectCreationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/QualifiedNameExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/SingleMemberAnnotationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/StringLiteralExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/SuperExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/ThisExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/UnaryExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/expr/VariableDeclarationExpr.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/AssertStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/BlockStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/BreakStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/CatchClause.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ContinueStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/DoStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/EmptyStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ExplicitConstructorInvocationStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ExpressionStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ForeachStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ForStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/IfStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/LabeledStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ReturnStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/Statement.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/SwitchEntryStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/SwitchStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/SynchronizedStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/ThrowStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/TryStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/TypeDeclarationStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/stmt/WhileStmt.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/ClassOrInterfaceType.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/PrimitiveType.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/ReferenceType.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/Type.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/VoidType.java \
  stubparser/src/org/checkerframework/stubparser/ast/type/WildcardType.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/DumpVisitor.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/GenericVisitor.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/GenericVisitorAdapter.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/ModifierVisitorAdapter.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/VoidVisitor.java \
  stubparser/src/org/checkerframework/stubparser/ast/visitor/VoidVisitorAdapter.java

  do
 native2ascii -encoding UTF8 ${s} ${s}
done

sed -i "s|mvn|xmvn -o|" maven-plugin/build.xml

# Disable reformats Java source code to comply with Google Java Style NOT supported
sed -i 's|depends="check-style"||' build.xml

# NOT usable
#/usr/share/javadoc/java-1.8.0-openjdk-1.8.0.77-1.b03.fc23/api
#<link href="http://docs.oracle.com/javase/8/docs/api/"/>
# NOT usable
#<link href="http://docs.oracle.com/javase/8/docs/jdk/api/javac/tree/"/>
#/usr/share/javadoc/java-1.8.0-openjdk-1.8.0.77-1.b03.fc23/jdk/api/javac/tree

%build

ant \
 -Djunit.lib=$(build-classpath junit) \
 -Dhamcrest.lib=$(build-classpath hamcrest/core) \
 -Djavac.lib=%{_jvmdir}/java/lib/tools.jar \
 -Djavadoc.bin="javadoc" \
 -Dcompiler.version.goal.java8="javac" \
 build javadoc

%install
# So do NOT NEED nothing else
%mvn_package org.checkerframework:dataflow dataflow
%mvn_package org.checkerframework:javacutil javacutil
%mvn_package org.checkerframework:stubparser stubparser
%mvn_artifact maven-plugin/poms/dataflowPom.xml dataflow/dist/dataflow.jar
%mvn_artifact maven-plugin/poms/javacutilPom.xml javacutil/dist/javacutil.jar
%mvn_artifact org.checkerframework:stubparser:%{version} stubparser/dist/stubparser.jar
%mvn_artifact org.checkerframework:framework:%{version} framework/dist/framework.jar
%mvn_install -J framework/api

# Unable to run test suite. See http://types.cs.washington.edu/checker-framework/current/checkers-manual.html#build-source
%if 0
%check
ant \
 -Djunit.lib=$(build-classpath junit) \
 -Dhamcrest.lib=$(build-classpath hamcrest/core) \
 -Djavac.lib=%{_jvmdir}/java/lib/tools.jar \
 -Dcompiler.version.goal.java8="javac" \
 tests-nojtreg
%endif

%files -f .mfiles
%doc changelog.txt README.txt README-developers.txt
%license LICENSE.txt

%files dataflow -f .mfiles-dataflow

%files javacutil -f .mfiles-javacutil
%doc changelog.txt README.txt README-developers.txt
%license LICENSE.txt

%files stubparser -f .mfiles-stubparser
%license stubparser/COPYING stubparser/COPYING.LESSER
%doc stubparser/README stubparser/readme.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Mon Apr 18 2016 gil cattaneo <puntogil@libero.it> 1.9.13-1
- update to 1.9.13

* Sat Feb 13 2016 gil cattaneo <puntogil@libero.it> 1.9.11-1
- initial rpm
